Bonobo.Git.Server/Controllers/RepositoryController.cs
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Web.Mvc;
using Bonobo.Git.Server.App_GlobalResources;
using Bonobo.Git.Server.Configuration;
using Bonobo.Git.Server.Data;
using Bonobo.Git.Server.Data.Update;
using Bonobo.Git.Server.Helpers;
using Bonobo.Git.Server.Models;
using Bonobo.Git.Server.Security;
using Ionic.Zip;
using Microsoft.Practices.Unity;
using MimeTypes;
using System.Security.Principal;

namespace Bonobo.Git.Server.Controllers
{
    public class RepositoryController : Controller
    {
        [Dependency]
        public ITeamRepository TeamRepository { get; set; }

        [Dependency]
        public IRepositoryRepository RepositoryRepository { get; set; }

        [Dependency]
        public IMembershipService MembershipService { get; set; }

        [Dependency]
        public IRepositoryPermissionService RepositoryPermissionService { get; set; }

        [Dependency]
        public IAuthenticationProvider AuthenticationProvider { get; set; }

        [WebAuthorize]
        public ActionResult Index(string sortGroup = null, string searchString = null)
        {
            var firstList = this.GetIndexModel();
            if (!string.IsNullOrEmpty(searchString))
            {
                var search = searchString.ToLower();
                firstList = firstList.Where(a => a.Name.ToLower().Contains(search) ||
                                            (!string.IsNullOrEmpty(a.Group) && a.Group.ToLower().Contains(search)) ||
                                            (!string.IsNullOrEmpty(a.Description) && a.Description.ToLower().Contains(search)))
                                            .AsEnumerable();
            }

            foreach(var item in firstList){
                SetGitUrls(item);
            }
            var list = firstList
                    .GroupBy(x => x.Group)
                    .OrderBy(x => x.Key, string.IsNullOrEmpty(sortGroup) || sortGroup.Equals("ASC"))
                    .ToDictionary(x => x.Key ?? string.Empty, x => x.ToArray());

            return View(list);
        }

        [WebAuthorizeRepository(RequiresRepositoryAdministrator = true)]
        public ActionResult Edit(Guid id)
        {
            var model = ConvertRepositoryModel(RepositoryRepository.GetRepository(id), User);
            PopulateCheckboxListData(ref model);
            return View(model);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        [WebAuthorizeRepository(RequiresRepositoryAdministrator = true)]
        public ActionResult Edit(RepositoryDetailModel model)
        {
            if (ModelState.IsValid)
            {
                var currentUserIsInAdminList = model.PostedSelectedAdministrators != null && model.PostedSelectedAdministrators.Contains(User.Id());
                if (currentUserIsInAdminList || User.IsInRole(Definitions.Roles.Administrator))
                {
                    var existingRepo = RepositoryRepository.GetRepository(model.Id);
                    var repoModel = ConvertRepositoryDetailModel(model);
                    MoveRepo(existingRepo, repoModel);
                    try
                    {
                        RepositoryRepository.Update(repoModel);
                    }
                    catch (System.Data.Entity.Infrastructure.DbUpdateException)
                    {
                        MoveRepo(repoModel, existingRepo);
                    }
                    ViewBag.UpdateSuccess = true;
                }
                else
                {
                    ModelState.AddModelError("Administrators", Resources.Repository_Edit_CantRemoveYourself);
                }
            }
            PopulateCheckboxListData(ref model);
            return View(model);
        }

        private void MoveRepo(RepositoryModel oldRepo, RepositoryModel newRepo)
        {
            if (oldRepo.Name != newRepo.Name)
            {
                string old_path = Path.Combine(UserConfiguration.Current.Repositories, oldRepo.Name);
                string new_path = Path.Combine(UserConfiguration.Current.Repositories, newRepo.Name);
                try
                {
                    Directory.Move(old_path, new_path);
                }
                catch (IOException exc)
                {
                    ModelState.AddModelError("Name", exc.Message);
                }
            }
        }

        [WebAuthorize]
        public ActionResult Create()
        {
            if (!RepositoryPermissionService.HasCreatePermission(User.Id()))
            {
                return RedirectToAction("Unauthorized", "Home");
            }

            var model = new RepositoryDetailModel
            {
                Administrators = new UserModel[] { MembershipService.GetUserModel(User.Id()) },
            };
            PopulateCheckboxListData(ref model);
            return View(model);
        }

        [HttpPost]
        [WebAuthorize]
        [ValidateAntiForgeryToken]
        public ActionResult Create(RepositoryDetailModel model)
        {
            if (!RepositoryPermissionService.HasCreatePermission(User.Id()))
            {
                return RedirectToAction("Unauthorized", "Home");
            }

            if (model != null && !String.IsNullOrEmpty(model.Name))
            {
                model.Name = Regex.Replace(model.Name, @"\s", "");
            }

            if (model != null && String.IsNullOrEmpty(model.Name))
            {
                ModelState.AddModelError("Name", Resources.Repository_Create_NameFailure);
            }
            else if (ModelState.IsValid)
            {

                var repo_model = ConvertRepositoryDetailModel(model);
                if (RepositoryRepository.Create(repo_model))
                {
                    string path = Path.Combine(UserConfiguration.Current.Repositories, model.Name);
                    if (!Directory.Exists(path))
                    {
                        LibGit2Sharp.Repository.Init(path, true);
                        TempData["CreateSuccess"] = true;
                        TempData["SuccessfullyCreatedRepositoryName"] = model.Name;
                        TempData["SuccessfullyCreatedRepositoryId"] = repo_model.Id;
                        return RedirectToAction("Index");
                    }
                    else
                    {
                        RepositoryRepository.Delete(model.Id);
                        ModelState.AddModelError("", Resources.Repository_Create_DirectoryExists);
                    }
                }
                else
                {
                    ModelState.AddModelError("", Resources.Repository_Create_Failure);
                }
            }
            PopulateCheckboxListData(ref model);
            return View(model);
        }

        [WebAuthorizeRepository(RequiresRepositoryAdministrator = true)]
        public ActionResult Delete(Guid id)
        {
            return View(ConvertRepositoryModel(RepositoryRepository.GetRepository(id), User));
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        [WebAuthorizeRepository(RequiresRepositoryAdministrator = true)]
        public ActionResult Delete(RepositoryDetailModel model)
        {
            if (model != null)
            {
                var repo = RepositoryRepository.GetRepository(model.Id);
                string path = Path.Combine(UserConfiguration.Current.Repositories, repo.Name);
                if (Directory.Exists(path))
                {
                    DeleteFileSystemInfo(new DirectoryInfo(path));
                }
                RepositoryRepository.Delete(repo.Id);
                TempData["DeleteSuccess"] = true;
            }
            return RedirectToAction("Index");
        }

        [WebAuthorizeRepository]
        public ActionResult Detail(Guid id)
        {
            ViewBag.ID = id;

            var model = ConvertRepositoryModel(RepositoryRepository.GetRepository(id), User);
            if (model != null)
            {
                model.IsCurrentUserAdministrator = RepositoryPermissionService.HasPermission(User.Id(), model.Id, RepositoryAccessLevel.Administer);
                SetGitUrls(model);
            }
            using (var browser = new RepositoryBrowser(Path.Combine(UserConfiguration.Current.Repositories, model.Name)))
            {
                string defaultReferenceName;
                browser.BrowseTree(null, null, out defaultReferenceName);
                RouteData.Values.Add("encodedName", defaultReferenceName);
            }

            return View(model);
        }

        /// <summary>
        /// Construct the URLs for the repository
        /// (This code extracted from the view)
        /// </summary>
        void SetGitUrls(RepositoryDetailModel model)
        {
            string serverAddress = System.Configuration.ConfigurationManager.AppSettings["GitServerPath"]
                                   ?? string.Format("{0}://{1}{2}{3}/",
                                       Request.Url.Scheme,
                                       Request.Url.Host,
                                       (Request.Url.IsDefaultPort ? "" : (":" + Request.Url.Port)),
                                       Request.ApplicationPath == "/" ? "" : Request.ApplicationPath
                                       );

            model.GitUrl = String.Concat(serverAddress, model.Name, ".git");
            if (User.Identity.IsAuthenticated)
            {
                model.PersonalGitUrl =
                    String.Concat(serverAddress.Replace("://", "://" + Uri.EscapeDataString(User.Username()) + "@"), model.Name, ".git");
            }
        }

        [WebAuthorizeRepository]
        public ActionResult Tree(Guid id, string encodedName, string encodedPath)
        {

Bonobo.Git.Server/Controllers/TeamController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;

using Bonobo.Git.Server.Data;
using Bonobo.Git.Server.Models;
using Bonobo.Git.Server.Security;
using Bonobo.Git.Server.App_GlobalResources;

using Microsoft.Practices.Unity;

namespace Bonobo.Git.Server.Controllers
{
    public class TeamController : Controller
    {
        [Dependency]
        public IMembershipService MembershipService { get; set; }

        [Dependency]
        public IRepositoryRepository RepositoryRepository { get; set; }

        [Dependency]
        public ITeamRepository TeamRepository { get; set; }

        [WebAuthorize(Roles = Definitions.Roles.Administrator)]
        public ActionResult Index()
        {
            return View(ConvertTeamModels(TeamRepository.GetAllTeams()));
        }

        [WebAuthorize(Roles = Definitions.Roles.Administrator)]
        public ActionResult Edit(Guid id)
        {
            var model = ConvertEditTeamModel(TeamRepository.GetTeam(id));
            return View(model);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        [WebAuthorize(Roles = Definitions.Roles.Administrator)]
        public ActionResult Edit(TeamEditModel model)
        {           
            if (ModelState.IsValid)
            {
                TeamRepository.Update(ConvertTeamDetailModel(model));
                ViewBag.UpdateSuccess = true;
            }
            model = ConvertEditTeamModel(TeamRepository.GetTeam(model.Id));
            return View(model);
        }

        [WebAuthorize(Roles = Definitions.Roles.Administrator)]
        public ActionResult Create()
        {
            var model = new TeamEditModel 
            {
                AllUsers = MembershipService.GetAllUsers().ToArray(),
                SelectedUsers = new UserModel[] { }
            };
            return View(model);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        [WebAuthorize(Roles = Definitions.Roles.Administrator)]
        public ActionResult Create(TeamEditModel model)
        {
            while (!String.IsNullOrEmpty(model.Name) && model.Name.Last() == ' ')
            {
                model.Name = model.Name.Substring(0, model.Name.Length - 1);
            }

            if (ModelState.IsValid)
            {
                var teammodel = ConvertTeamDetailModel(model);
                if (TeamRepository.Create(teammodel))
                {
                    TempData["CreateSuccess"] = true;
                    TempData["NewTeamId"] = teammodel.Id;
                    return RedirectToAction("Index");
                }
                else
                {
                    ModelState.AddModelError("", Resources.Team_Create_Failure);
                }
            }

            return View(model);
        }

        [WebAuthorize(Roles = Definitions.Roles.Administrator)]
        public ActionResult Delete(Guid id)
        {
            return View(ConvertEditTeamModel(TeamRepository.GetTeam(id)));
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        [WebAuthorize(Roles = Definitions.Roles.Administrator)]
        public ActionResult Delete(TeamEditModel model)
        {
            if (model != null && model.Id != null)
            {
                TeamModel team = TeamRepository.GetTeam(model.Id);
                TeamRepository.Delete(team.Id);
                TempData["DeleteSuccess"] = true;
                return RedirectToAction("Index");
            }
            return RedirectToAction("Index");
        }

        [WebAuthorize]
        public ActionResult Detail(Guid id)
        {
            return View(ConvertDetailTeamModel(TeamRepository.GetTeam(id)));
        }


        private TeamDetailModelList ConvertTeamModels(IEnumerable<TeamModel> models)
        {
            var result = new TeamDetailModelList();
            result.IsReadOnly = MembershipService.IsReadOnly();
            foreach (var item in models)
            {
                result.Add(ConvertDetailTeamModel(item));
            }
            return result;
        }

        private TeamEditModel ConvertEditTeamModel(TeamModel model)
        {
            return model == null ? null : new TeamEditModel
            {
                Id = model.Id,
                Name = model.Name,
                Description = model.Description,
                AllUsers = MembershipService.GetAllUsers().ToArray(),
                SelectedUsers = model.Members.ToArray(),
            };
        }

        private TeamDetailModel ConvertDetailTeamModel(TeamModel model)
        {
            return model == null ? null : new TeamDetailModel
            {
                Id = model.Id,
                Name = model.Name,
                Description = model.Description,
                Members = model.Members.ToArray(),
                Repositories = RepositoryRepository.GetTeamRepositories(new[] { model.Id }).ToArray(),
                IsReadOnly = MembershipService.IsReadOnly()
            };
        }

        private TeamModel ConvertTeamDetailModel(TeamEditModel model)
        {
            return new TeamModel
            {
                Id = model.Id,
                Name = model.Name,
                Description = model.Description,
                Members = model.PostedSelectedUsers == null ? new UserModel[0] : model.PostedSelectedUsers.Select(x => MembershipService.GetUserModel(x)).ToArray(),
            };
        }
    }
}

Bonobo.Git.Server/Views/Repository/Clone.cshtml
@using MvcCheckBoxList.Model
@model RepositoryDetailModel
@{
    ViewBag.Title = Resources.Repository_Clone_Title;
}
<h1>@Resources.Repository_Clone_Title</h1>

@using (Html.BeginForm("Clone", "Repository", new { id = ViewBag.ID }, FormMethod.Post, new { @class = "pure-form pure-form-aligned" }))
{    
    @Html.AntiForgeryToken()
    @Html.ValidationSummary(false, Resources.Repository_Clone_Fail)
    
    <fieldset>
        <div class="pure-control-group">
            @Html.LabelFor(m => m.Name)
            @Html.TextBoxFor(m => m.Name, new { autofocus = "" })<em>*</em>
            @Html.ValidationMessageFor(m => m.Name)
        </div>
        <div class="pure-control-group">
            @Html.LabelFor(m => m.Group)
            @Html.TextBoxFor(m => m.Group, new { @class = "medium" })
        </div>
        <div class="pure-control-group">
            @Html.LabelFor(m => m.Description)
            @Html.TextAreaFor(m => m.Description, new { @class = "medium" })
        </div>
        <div class="pure-control-group">
            @Html.LabelFor(m => m.AllowAnonymous)
            @Html.CheckBoxFor(m => m.AllowAnonymous)
            <i class="fa fa-info-circle" title="@Resources.Repository_AllowAnonymousHint"></i>
        </div>
        <div class="pure-control-group checkboxlist">
            @Html.LabelFor(m => m.Users)
            <span>
            	@Html.CheckBoxListFor(m => m.PostedSelectedUsers, mm => mm.AllUsers, mm => mm.Id, mm => mm.DisplayName, mm => mm.Users, Position.Vertical)
            </span>
            <i class="fa fa-info-circle" title="@Resources.Repository_UsersHint"></i>
        </div>

        <div class="pure-control-group checkboxlist">
            @Html.LabelFor(m => m.Administrators)
            <span>
            	@Html.CheckBoxListFor(m => m.PostedSelectedAdministrators, mm => mm.AllAdministrators, mm => mm.Id, mm => mm.DisplayName, mm => mm.Administrators, Position.Vertical)
            </span>
            @Html.ValidationMessageFor(m => m.Administrators)
            <i class="fa fa-info-circle" title="@Resources.Repository_AdministratorsHint"></i>
        </div>

        <div class="pure-control-group checkboxlist">
            @Html.LabelFor(m => m.Teams)
            <span>
            	@Html.CheckBoxListFor(m => m.PostedSelectedTeams, mm => mm.AllTeams, mm => mm.Id, mm => mm.DisplayName, mm => mm.Teams, Position.Vertical)
            </span>
            <i class="fa fa-info-circle" title="@Resources.Repository_TeamsHint"></i>
        </div>



        <div class="pure-controls">
            <a class="pure-button" href="@Url.Action("Index")"><i class="fa fa-long-arrow-left"></i> @Resources.Repository_Back</a>
            <button type="submit" class="pure-button pure-button-primary"><i class="fa fa-copy"></i> @Resources.Repository_Clone_Submit</button>
        </div>
    </fieldset>
}

Bonobo.Git.Server/Views/Repository/Create.cshtml
@using Bonobo.Git.Server.Extensions
@using MvcCheckBoxList.Model
@model Bonobo.Git.Server.Models.RepositoryDetailModel
@{
    ViewBag.Title = Resources.Repository_Create_Title;
}
<h1>@Resources.Repository_Create_Title</h1>

@using (Html.BeginForm("Create", "Repository", FormMethod.Post, new { @class = "pure-form pure-form-aligned", enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()
    @Html.ValidationSummary(false, Resources.Repository_Create_Fail)
    
    <fieldset>
        <div class="pure-control-group">
            @Html.LabelFor(m => m.Name)
            @Html.TextBoxFor(m => m.Name, new {autofocus = ""})<em>*</em>
            @Html.ValidationMessageFor(m => m.Name)
        </div>
        <div class="pure-control-group">
            @Html.LabelFor(m => m.Group)
            @Html.TextBoxFor(m => m.Group, new { @class = "medium" })
        </div>
        <div class="pure-control-group">
            @Html.LabelFor(m => m.Description)
            @Html.TextAreaFor(m => m.Description, new { @class = "medium" })
        </div>
        <div class="pure-control-group">
            @Html.LabelFor(m => m.Logo.PostedFile)
            <input type="file" name="Logo.PostedFile" id="Logo_PostedFile" />
            <sup>.png, .jpg, .jpeg, .gif</sup>
        </div>

            <div class="pure-control-group">
                @Html.LabelFor(m => m.AllowAnonymous)
                @Html.CheckBoxFor(m => m.AllowAnonymous, new { @onClick = "document.getElementById('AllowAnonymousPush').disabled = !this.checked" })
                <i class="fa fa-info-circle" title="@Resources.Repository_AllowAnonymousHint"></i>
            </div>

            <div class="pure-control-group">
                @Html.LabelFor(m => m.AllowAnonymousPush)
                @{
                    object attribs = new { @id = "AllowAnonymousPush" };
                    if (!Model.AllowAnonymous){
                        attribs = new { @id = "AllowAnonymousPush", @disabled = "" }; 
                    }
                }
                @Html.EnumDropDownListFor(m => m.AllowAnonymousPush, attribs)
                <i class="fa fa-info-circle" title="@Resources.Repository_AllowAnonymousPushHint"></i>
            </div>
        <div class="pure-control-group">
            @Html.LabelFor(m => m.LinksUseGlobal)
            @Html.CheckBoxFor(m => m.LinksUseGlobal, new { @onClick = "document.getElementById('LinksRegex').disabled = this.checked; document.getElementById('LinksUrl').disabled = this.checked" })
        </div>
        <div class="pure-control-group">
            @Html.LabelFor(m => m.LinksRegex)
            @{
                attribs = new { @class = "medium" };
                if (Model.LinksUseGlobal){
                    attribs = new { @class = "medium", disabled = "" };
                }
                @Html.TextBoxFor(m => m.LinksRegex, attribs);
                @Html.ValidationMessageFor(m => m.LinksRegex);
            }
        </div>
        <div class="pure-control-group">
            @Html.LabelFor(m => m.LinksUrl)
            @Html.TextBoxFor(m => m.LinksUrl, attribs)
            <i class="fa fa-info-circle" title="@Resources.Settings_Global_LinksUrl_Hint"></i>
        </div>
            <div class="pure-control-group checkboxlist">
                @Html.LabelFor(m => m.Users)
                <span>
                    @Html.CheckBoxListFor(m => m.PostedSelectedUsers, mm => mm.AllUsers, mm => mm.Id, mm => mm.DisplayName, mm => mm.Users, Position.Vertical)
                </span>
                <i class="fa fa-info-circle" title="@Resources.Repository_UsersHint"></i>
            </div>

            <div class="pure-control-group checkboxlist">
                @Html.LabelFor(m => m.Administrators)
                <span>
                    @Html.CheckBoxListFor(m => m.PostedSelectedAdministrators, mm => mm.AllAdministrators, mm => mm.Id, mm => mm.DisplayName, mm => mm.Administrators, Position.Vertical)
                </span>
                @Html.ValidationMessageFor(m => m.Administrators)
                <i class="fa fa-info-circle" title="@Resources.Repository_AdministratorsHint"></i>
            </div>

            <div class="pure-control-group checkboxlist">
                @Html.LabelFor(m => m.Teams)
                <span>
                    @Html.CheckBoxListFor(m => m.PostedSelectedTeams, mm => mm.AllTeams, mm => mm.Id, mm => mm.DisplayName, mm => mm.Teams, Position.Vertical)
                </span>
                <i class="fa fa-info-circle" title="@Resources.Repository_TeamsHint"></i>
            </div>



            <div class="pure-controls">
                <a class="pure-button" href="@Url.Action("Index")"><i class="fa fa-long-arrow-left"></i> @Resources.Repository_Back</a>
                <button type="submit" class="pure-button pure-button-primary"><i class="fa fa-save"></i> @Resources.Repository_Create_Submit</button>
            </div>
</fieldset>
}

Bonobo.Git.Server/Views/Repository/Delete.cshtml
@model Bonobo.Git.Server.Models.RepositoryDetailModel
@{
    ViewBag.Title = Resources.Delete_Title;
}

<h1>@Resources.Confirm</h1>
<div>
    <p class="summary-error">@String.Format(Resources.Delete_ConfirmationText, Model.Name)</p>
</div>

@using (Html.BeginForm("Delete", "Repository", FormMethod.Post, new { @class = "pure-form" }))
{
    @Html.AntiForgeryToken()
    <fieldset class="deleteForm">
        @Html.HiddenFor(m => m.Name)
        @Html.HiddenFor(m => m.Id)
        <div class="pure-controls">
            <a class="pure-button" href="@Url.Action("Index")"><i class="fa fa-long-arrow-left"></i> @Resources.Delete_Back</a>
            <button type="submit" class="pure-button pure-button-primary"><i class="fa fa-trash-o"></i> @Resources.Delete_Confirm</button>
        </div>
    </fieldset>
}

Bonobo.Git.Server/Views/Repository/Detail.cshtml
@model Bonobo.Git.Server.Models.RepositoryDetailModel
@{
    Layout = "~/Views/Repository/_RepositoryLayout.cshtml";
    ViewBag.Title = Resources.Repository_Detail_Title;
}
@if (Model != null)
{
    <div class="pure-form pure-form-aligned detail">
        <fieldset>
            <div class="pure-control-group">
                @Html.LabelFor(m => m.Name)
                @Model.Name
                @switch (Model.Status)
                {
                    case RepositoryDetailStatus.Valid:
                        break;
                    case RepositoryDetailStatus.Missing:
                        <span class="status">(Missing)</span>
                        break;
                    case RepositoryDetailStatus.Unknown:
                    default:
                    <span class="status">(Status Unknown)</span>
                        break;
                }
            </div>
            <div class="pure-control-group">
                <label>@Resources.Repository_Detail_Location</label>
                <button class="pure-button copy-to-clip-button" data-clipboard-target=".git-url-text"><i class="fa fa-copy"></i>@Resources.Copy</button>
                <span class="git-url-text">@Model.GitUrl</span>
            </div>

            @if (User.Identity.IsAuthenticated) {
                <div class="pure-control-group">
                    <label>
                        @Resources.Repository_Detail_Location_Personal
                    </label>
                    <button class="pure-button copy-to-clip-button" data-clipboard-target=".personal-url-text"><i class="fa fa-copy"></i>@Resources.Copy</button>
                    <span class="personal-url-text">@Model.PersonalGitUrl</span>
                </div>
            }

            <div class="pure-control-group">
                @Html.LabelFor(m => m.Group)
                @Model.Group
            </div>
            <div class="pure-control-group">
                @Html.LabelFor(m => m.Description)
                @Model.Description
            </div>
            <div class="pure-control-group">
                @Html.LabelFor(m => m.AllowAnonymous)
                @if (Model.AllowAnonymous)
                {
                    @Resources.Repository_Detail_Yes
                }
                else
                {
                    @Resources.Repository_Detail_No
                }
            </div>
            <div class="pure-control-group">
                @Html.LabelFor(m => m.AllowAnonymousPush)
                @Html.DisplayEnum(Model.AllowAnonymousPush)
            </div>

            <div class="pure-control-group">
                @Html.LabelFor(m => m.LinksUseGlobal)
                @Html.CheckBoxFor(m => m.LinksUseGlobal, new { disabled=""})
            </div>
            <div class="pure-control-group">
                @Html.LabelFor(m => m.LinksRegex)
                @Html.TextBoxFor(m => m.LinksRegex, new { @readonly=""})
            </div>
            <div class="pure-control-group">
                @Html.LabelFor(m => m.LinksUrl)
                @Html.TextBoxFor(m => m.LinksUrl, new { @readonly=""})
            </div>
            @if (AppSettings.IsPushAuditEnabled) {
                <div class="pure-control-group">
                    @Html.LabelFor(m => m.AuditPushUser)
                    @if (Model.AuditPushUser)
                    {
                        @Resources.Repository_Detail_Yes
                    }
                    else
                    {
                        @Resources.Repository_Detail_No
                    }
                </div>
            }
                <div class="pure-control-group">
                @Html.LabelFor(m => m.Users)
                @for (int i = 0; i < Model.Users.Length; i++)
                {
                        @Html.ActionLink(@Model.Users[i].DisplayName, "Detail", "Account", new { id = @Model.Users[i].Id}, new { title = @Model.Users[i].Username })
                        if (i + 1 != Model.Users.Length)
                        {
                            <text>, </text>
                        }
                    }
                </div>
                <div class="pure-control-group">
                @Html.LabelFor(m => m.Administrators)
                @for (int i = 0; i < Model.Administrators.Length; i++)
                    {
                        @Html.ActionLink(@Model.Administrators[i].DisplayName, "Detail", "Account", new { id = @Model.Administrators[i].Id }, new { title = @Model.Administrators[i].Username })
                        if (i + 1 != Model.Administrators.Length)
                        {
                            <text>, </text>
                        }
                    }
                </div>
                    <div class="pure-control-group">
                        @Html.LabelFor(m => m.Teams)
                        @for (int i = 0; i < Model.Teams.Length; i++)
                        {
                            @Html.ActionLink(@Model.Teams[i].DisplayName, "Detail", "Team", new { id = @Model.Teams[i].Id }, null)
                            if (i + 1 != Model.Teams.Length)
                            {
                                <text>, </text>
                            }
                        }
                    </div>
                <div class="pure-controls">
                <a class="pure-button" href="@Url.Action("Index")"><i class="fa fa-long-arrow-left"></i> @Resources.Repository_Detail_Back</a>
                @if (Model.IsCurrentUserAdministrator)
                {
                    <a class="pure-button" href="@Url.Action("Edit", new { id = Model.Id })"><i class="fa fa-pencil-square-o"></i> @Resources.Repository_Detail_Edit</a>
                    <a class="pure-button" href="@Url.Action("Delete", new { id = Model.Id })"><i class="fa fa-trash-o"></i> @Resources.Repository_Detail_Delete</a>
                }
                </div>
</fieldset>
    </div>
}

@section scripts
{
    <script>new Clipboard('.copy-to-clip-button');</script>
}